<html>
<head>
<title>OGRE: OgreSubEntity.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreSubEntity.h</h1><a href="OgreSubEntity_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __SubEntity_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __SubEntity_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreString_8h.html">OgreString.h</a>"</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include "<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>"</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include "<a class="code" href="OgreHardwareBufferManager_8h.html">OgreHardwareBufferManager.h</a>"</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00056"></a><a class="code" href="classOgre_1_1SubEntity.html">00056</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SubEntity.html" title="Utility class which defines the sub-parts of an Entity.">SubEntity</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>
<a name="l00057"></a>00057     {
<a name="l00058"></a>00058         <span class="comment">// Note no virtual functions for efficiency</span>
<a name="l00059"></a><a class="code" href="classOgre_1_1SubEntity.html#614439ccac0344926adc4c0165d64060">00059</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1Entity.html" title="Defines an instance of a discrete, movable object based on a Mesh.">Entity</a>;
<a name="l00060"></a><a class="code" href="classOgre_1_1SubEntity.html#284464b0561a6f2915f04b0245b987f0">00060</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &amp;#39;scene&amp;#39; i.e.">SceneManager</a>;
<a name="l00061"></a>00061     <span class="keyword">protected</span>:
<a name="l00064"></a>00064         <a class="code" href="classOgre_1_1SubEntity.html" title="Utility class which defines the sub-parts of an Entity.">SubEntity</a>(<a class="code" href="classOgre_1_1Entity.html" title="Defines an instance of a discrete, movable object based on a Mesh.">Entity</a>* parent, <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* subMeshBasis);
<a name="l00065"></a>00065 
<a name="l00068"></a>00068         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1SubEntity.html" title="Utility class which defines the sub-parts of an Entity.">SubEntity</a>();
<a name="l00069"></a>00069 
<a name="l00071"></a><a class="code" href="classOgre_1_1SubEntity.html#a96672e40c650856388969f3f3e568a3">00071</a>         <a class="code" href="classOgre_1_1Entity.html" title="Defines an instance of a discrete, movable object based on a Mesh.">Entity</a>* mParentEntity;
<a name="l00072"></a>00072 
<a name="l00074"></a><a class="code" href="classOgre_1_1SubEntity.html#1414ab7a758f77b4c59d125f2e299125">00074</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mMaterialName;
<a name="l00075"></a>00075 
<a name="l00077"></a><a class="code" href="classOgre_1_1SubEntity.html#1a0351b31d75bf5355e67c2b62f0ab8b">00077</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> mpMaterial;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079         <span class="comment">// Pointer to the SubMesh defining geometry.</span>
<a name="l00080"></a><a class="code" href="classOgre_1_1SubEntity.html#1576543e6cdc3cafb75b91f8035612ef">00080</a>         <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* mSubMesh;
<a name="l00081"></a>00081 
<a name="l00083"></a><a class="code" href="classOgre_1_1SubEntity.html#e873abec94f7c3de277486de75ff969a">00083</a>         <span class="keywordtype">bool</span> mVisible;
<a name="l00084"></a>00084 
<a name="l00086"></a><a class="code" href="classOgre_1_1SubEntity.html#151ff07c40ae1063e1336b8637ca4bd2">00086</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> mMaterialLodIndex;
<a name="l00087"></a>00087 
<a name="l00089"></a><a class="code" href="classOgre_1_1SubEntity.html#232dcbeb184aad2f6b415d7548c93d38">00089</a>         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* mSkelAnimVertexData;
<a name="l00091"></a><a class="code" href="classOgre_1_1SubEntity.html#4c17cfd5eae6cecf9d601e367efd34cc">00091</a>         <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html" title="Structure for recording the use of temporary blend buffers.">TempBlendedBufferInfo</a> mTempSkelAnimInfo;
<a name="l00093"></a><a class="code" href="classOgre_1_1SubEntity.html#6191ebd40cd698d1bf68800c37a0aff4">00093</a>         <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html" title="Structure for recording the use of temporary blend buffers.">TempBlendedBufferInfo</a> mTempVertexAnimInfo;
<a name="l00095"></a><a class="code" href="classOgre_1_1SubEntity.html#bbd853a7c3319feadedc09a3874fdf7e">00095</a>         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* mSoftwareVertexAnimVertexData;
<a name="l00099"></a><a class="code" href="classOgre_1_1SubEntity.html#dd80eca6e17aaafeff9a5a913f00e641">00099</a>         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* mHardwareVertexAnimVertexData;
<a name="l00101"></a><a class="code" href="classOgre_1_1SubEntity.html#e4b715172cc5ab8c59a655ba3d8ce1b7">00101</a>         <span class="keywordtype">bool</span> mVertexAnimationAppliedThisFrame;
<a name="l00103"></a><a class="code" href="classOgre_1_1SubEntity.html#4527fcf72f8fd40d66c0eaf9b7aaf978">00103</a>         <a class="code" href="namespaceOgre.html#f851e71354d841df7138f9877c6f5931">ushort</a> mHardwarePoseCount;
<a name="l00105"></a><a class="code" href="classOgre_1_1SubEntity.html#583d2a382488261388c88264cc5dd5eb">00105</a>         <span class="keyword">mutable</span> <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> mCachedCameraDist;
<a name="l00107"></a><a class="code" href="classOgre_1_1SubEntity.html#0cafd29d50d9f2dd1cd7201f96b742b5">00107</a>         <span class="keyword">mutable</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *mCachedCamera;
<a name="l00108"></a>00108 
<a name="l00110"></a>00110         <span class="keywordtype">void</span> prepareTempBlendBuffers(<span class="keywordtype">void</span>);
<a name="l00111"></a>00111 
<a name="l00112"></a>00112     <span class="keyword">public</span>:
<a name="l00115"></a>00115         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMaterialName() <span class="keyword">const</span>;
<a name="l00116"></a>00116 
<a name="l00123"></a>00123         <span class="keywordtype">void</span> setMaterialName( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name );
<a name="l00124"></a>00124 
<a name="l00126"></a>00126         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setVisible(<span class="keywordtype">bool</span> visible);
<a name="l00127"></a>00127 
<a name="l00129"></a>00129         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isVisible(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00130"></a>00130 
<a name="l00133"></a>00133         <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* getSubMesh(<span class="keywordtype">void</span>);
<a name="l00134"></a>00134 
<a name="l00136"></a><a class="code" href="classOgre_1_1SubEntity.html#1b3670ec0b19ba7b876fb53634a666cf">00136</a>         <a class="code" href="classOgre_1_1Entity.html" title="Defines an instance of a discrete, movable object based on a Mesh.">Entity</a>* getParent(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mParentEntity; }
<a name="l00137"></a>00137 
<a name="l00140"></a>00140         <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00141"></a>00141 
<a name="l00144"></a>00144         <a class="code" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>* getTechnique(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00145"></a>00145 
<a name="l00148"></a>00148         <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&amp;#39;New&amp;#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l00149"></a>00149 
<a name="l00152"></a>00152         <span class="keywordtype">void</span> getWorldTransforms(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogenous matrix.">Matrix4</a>* xform) <span class="keyword">const</span>;
<a name="l00154"></a>00154         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; getWorldOrientation(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00156"></a>00156         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getWorldPosition(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00159"></a>00159         <span class="keywordtype">bool</span> getNormaliseNormals(<span class="keywordtype">void</span>) <span class="keyword">const</span>;      
<a name="l00162"></a>00162         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumWorldTransforms(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00164"></a>00164         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getSquaredViewDepth(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam) <span class="keyword">const</span>;
<a name="l00166"></a>00166         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#b82c6299605910b4051ebb3cc3e5539e">LightList</a>&amp; getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00168"></a>00168         <span class="keywordtype">bool</span> getCastsShadows(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00178"></a>00178         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* _getSkelAnimVertexData(<span class="keywordtype">void</span>);
<a name="l00187"></a>00187         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* _getSoftwareVertexAnimVertexData(<span class="keywordtype">void</span>);
<a name="l00192"></a>00192         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* _getHardwareVertexAnimVertexData(<span class="keywordtype">void</span>);
<a name="l00196"></a>00196         <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html" title="Structure for recording the use of temporary blend buffers.">TempBlendedBufferInfo</a>* _getSkelAnimTempBufferInfo(<span class="keywordtype">void</span>);
<a name="l00200"></a>00200         <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html" title="Structure for recording the use of temporary blend buffers.">TempBlendedBufferInfo</a>* _getVertexAnimTempBufferInfo(<span class="keywordtype">void</span>);
<a name="l00202"></a>00202         <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* getVertexDataForBinding(<span class="keywordtype">void</span>);
<a name="l00203"></a>00203 
<a name="l00206"></a>00206         <span class="keywordtype">void</span> _markBuffersUnusedForAnimation(<span class="keywordtype">void</span>);
<a name="l00209"></a>00209         <span class="keywordtype">void</span> _markBuffersUsedForAnimation(<span class="keywordtype">void</span>);
<a name="l00211"></a><a class="code" href="classOgre_1_1SubEntity.html#8e00545c24b8ca8674aeec00567ce4cd">00211</a>         <span class="keywordtype">bool</span> _getBuffersMarkedForAnimation(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexAnimationAppliedThisFrame; }
<a name="l00215"></a>00215         <span class="keywordtype">void</span> _restoreBuffersForUnusedAnimation(<span class="keywordtype">bool</span> hardwareAnimation);
<a name="l00216"></a>00216 
<a name="l00218"></a>00218         <span class="keywordtype">void</span> _updateCustomGpuParameter(
<a name="l00219"></a>00219             <span class="keyword">const</span> <a class="code" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html" title="Structure recording the use of an automatic parameter.">GpuProgramParameters::AutoConstantEntry</a>&amp; constantEntry,
<a name="l00220"></a>00220             <a class="code" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>* params) <span class="keyword">const</span>;
<a name="l00221"></a>00221 
<a name="l00223"></a><a class="code" href="classOgre_1_1SubEntity.html#bed92cd6152d752dccb46b4ef7a2874f">00223</a>         <span class="keywordtype">void</span> _invalidateCameraCache ()
<a name="l00224"></a>00224         { mCachedCamera = 0; }
<a name="l00225"></a>00225     };
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
